﻿//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
#define VERSION "1.00"
#property copyright ""
#property description "Versão de Testes"
#property link      ""
#property version VERSION
#property strict

bool Debug = true;
bool DebugSuccess = false, DebugError = true, enablePointerSuccess = false, DebugTemp = true;

#include <Trade\SymbolInfo.mqh>
CSymbolInfo SymbolInfo;

#include <Trade\Trade.mqh>
CTrade trade;

#include <PositionInfoMy.mqh>
CPositionInfoMy *PositionInfoMyBuy;
CPositionInfoMy *PositionInfoMySell;

#include <Arrays\ArrayObj.mqh>
CArrayObj *ArrayPositionsBuy = new CArrayObj;
CArrayObj *ArrayPositionsSell = new CArrayObj;

#include  <errordescription.mqh>

enum EnumLanguages {Default, English, Portugues};

EnumLanguages Language  =	((TerminalInfoString(TERMINAL_LANGUAGE) == "Portuguese (Brazil)" || TerminalInfoString(TERMINAL_LANGUAGE) == "Portuguese (Portugal)") ? Portugues : English);
#define FunctionLine ((Language==Portugues ? " Função: "+__FUNCTION__+" linha: "+(string)__LINE__+" magic: "+ (string)Magic +" versão: " : "Function: "+__FUNCTION__+" line: "+(string)__LINE__+" magic: "+ (string)Magic +" version: ")+(string)VERSION)
#define SLEEP_AFTER_EXECUTION_FAIL 1000
#define TRIES_OPEN_CLOSE_MODIFY_DELETE 5	//Tentativas de abrir/modificar/excluir/fechar uma ordem/posição.
#define PrintDebugErrorFunctionMessage(lFunctionMessage) if(DebugError)	Print(lFunctionMessage + FunctionLine);
#define PrintDebugTempFunctionMessage(lFunctionMessage) if(DebugTemp)	Print(lFunctionMessage + FunctionLine);
#define LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass, lCountTries) 			static bool lIsFirstPass = true;			static int lCountTries = 0;
#define LoopPrint2CountLooplCountTries(lCountTries)            if(Debug){					if(lCountTries < TRIES_OPEN_CLOSE_MODIFY_DELETE){				lCountTries++;
#define LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass)					} else { if(lIsFirstPass){ lIsFirstPass = false;	Print("O EA entrou em loop na " + FunctionLine);}	Sleep(SLEEP_AFTER_EXECUTION_FAIL);		}	}
#define LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass, lCountTries)	if(!lIsFirstPass){	lIsFirstPass = true;	lCountTries = 0;	if(Debug) Print("O EA saiu do loop na " + FunctionLine);}
#define IsFirstPassDeclaration1(lIsFirstPass)		static bool lIsFirstPass = true;
#define IfIsFirstPass2Commands(lIsFirstPass, lCommands) 		if(lIsFirstPass){	lIsFirstPass = false;	lCommands	}
#define PrintDebugErrorIsFirstPass2FunctionMessage(lIsFirstPass, lFunctionMessage) 		if(DebugError){	if(lIsFirstPass){	Print(lFunctionMessage + FunctionLine);	lIsFirstPass = false;	}	}
#define ElseIsFirstPass3(lIsFirstPass)	   if(!lIsFirstPass)	{	lIsFirstPass = true;  }
#define PointerCreateWhileInvalidlCountPntrNameArryNamIndxCmmndsExtrs5P(lCount,PointerName,ArrayName,lIndex,CommandsExtras)      int lCount=0;	while(((PointerName=ArrayName.At(lIndex))==NULL || CheckPointer(PointerName)==POINTER_INVALID) && lCount<TRIES_OPEN_CLOSE_MODIFY_DELETE)      {    lCount++;			PrintDebugErrorFunctionMessage("O ponteiro é NULL."+AtError("Array"));      }      if((PointerName==NULL || CheckPointer(PointerName)==POINTER_INVALID) && lCount>=TRIES_OPEN_CLOSE_MODIFY_DELETE)      {      	PrintDebugErrorFunctionMessage("O ponteiro é NULL e não foi possível torná-lo válido após "+IntegerToString(TRIES_OPEN_CLOSE_MODIFY_DELETE)      											+" tentativas.");      	CommandsExtras;      }
#define PointerAtribWhileInvalidlIsFstPssPntrNameCnstrctrWthPrm(lIsFirstPass,PointerName,PointerTypeConstructorWithParameters)			   IsFirstPassDeclaration1(lIsFirstPass);	  while((PointerName = new PointerTypeConstructorWithParameters) == NULL || CheckPointer(PointerName)==POINTER_INVALID)			   {			   	PrintDebugErrorIsFirstPass2FunctionMessage(lIsFirstPass, 			   															"Falha ao criar o objeto/ponteiro.");			   }			   ElseIsFirstPass3(lIsFirstPass);

sinput ulong            Magic     			= 6199;                           //Magic Number
input ENUM_TIMEFRAMES 	Timeframe					= PERIOD_CURRENT;	//Timeframe da barra de análise

static int					Slippage						= 0;		//Derrapagem (pontos) para abrir ou fechar uma ordem. 0 desativa.

MqlTradeRequest TrReq;
MqlTradeResult trRes;
MqlTradeCheckResult checkResult;

bool bglArrayPositionsBuyAndSellCheckToDeleteClosedPositionsElements=false;

int OnInit()
{
 return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   delete ArrayPositionsBuy;
   delete ArrayPositionsSell;
}

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
	MqlDateTime Today;
	TimeCurrent(Today);
	MqlDateTime TodayPrevious;
	//I tried use local pointers first, after many atempts to solution I'tried global pointers
	//if new day, try to deallocate memory RAM, I try this after many attempts, if you have a better solution, please share with me, I'm new in 
	//pointers and classes works.
   if(TodayPrevious.day_of_year != Today.day_of_year)	
   {
//PrintDebugTempFunctionMessage("ArrayPositionsBuy.FreeMode() "+ArrayPositionsBuy.FreeMode()+
//										" ArrayPositionsSell.FreeMode() "+ArrayPositionsSell.FreeMode());
//		ArrayPositionsBuy.FreeMode(false);
//		ArrayPositionsSell.FreeMode(false);
		bool bloDeleted = true;
		if(ArrayPositionsBuy.Total()>0 && !ArrayDeleteAllPositions(ArrayPositionsBuy))
		{
			PrintDebugErrorFunctionMessage("Não conseguiu deletar os elementos do ArrayPositionsBuy.");
			bloDeleted = false;
		}
		else
		  {
		  	ArrayPositionsBuy = new CArrayObj();
		  }
		if(ArrayPositionsSell.Total()>0 && !ArrayDeleteAllPositions(ArrayPositionsSell))
		{
			PrintDebugErrorFunctionMessage("Não conseguiu deletar os elementos do ArrayPositionsSell.");
			bloDeleted = false;
		}
		else
		  {
		  	ArrayPositionsSell = new CArrayObj();
		  }
		if(bloDeleted)
		  {
		   TodayPrevious.day_of_year = Today.day_of_year;
		  }
	}
	PointerDeleteWhenArrayIsEmpty();
	
	if(IsNewBar(_Symbol, Timeframe))
   {
   	//open buy and sell
   	if(!PositionOpenOrderCheckSend(ORDER_TYPE_BUY,_Symbol,Magic,0.01))
	   {
	   	PrintDebugErrorFunctionMessage(ReturnedFalseError("PositionOpenOrderCheckSend Buy"));
	   }
   	if(!PositionOpenOrderCheckSend(ORDER_TYPE_SELL,_Symbol,Magic,0.01))
	   {
	   	PrintDebugErrorFunctionMessage(ReturnedFalseError("PositionOpenOrderCheckSend Sell"));
	   }
   }
   
   //if profit is positive, store in the respective array
   //update profit positions at array
   PositionsProfit(_Symbol, Magic);

	//if buy and sell profit is positive, then close both
	if(ArrayPositionsBuy.Total()>0 && ArrayPositionsSell.Total()>0)
	  {
   	if(!PositionCloseAndCheckAllPairByType(POSITION_TYPE_BUY,_Symbol,Magic))
	     {
	      PrintDebugErrorFunctionMessage(ReturnedFalseError("PositionCloseAndCheckAllPairByType Buy"));
	     }
   	if(!PositionCloseAndCheckAllPairByType(POSITION_TYPE_SELL,_Symbol,Magic))
	     {
	      PrintDebugErrorFunctionMessage(ReturnedFalseError("PositionCloseAndCheckAllPairByType Sell"));
	     }
	  }     
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double PositionsProfit(string lSymbol, ulong lMagicNumber)
{//adaptar
   double dloProfitPositions = 0;
   
//calcular o profit das positions.
   for(int i = 0; i < PositionsTotal(); i++)
   {
      LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass2, lCountTries2)
      if((PositionGetTicket(i)) == 0)  	//recomeça tentativas de modificação
      {
         LoopPrint2CountLooplCountTries(lCountTries2)
         Print("Ticket==0" + FunctionLine);
         LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass2)
         i = 0;
         dloProfitPositions = 0;
         continue;
      }
      else
      {
         LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass2, lCountTries2);

         if(PositionGetString(POSITION_SYMBOL) == lSymbol && PositionGetInteger(POSITION_MAGIC) == lMagicNumber)
         {
			      if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY)
			      {
			         if(!ArrayPositionsBuyProfitAndNewPositionsUpdate())
			         {
			         	PrintDebugErrorFunctionMessage(ReturnedFalseError("ArrayPositionsBuyProfitAndNewPositionsUpdate"));
			         }
			        }
		         else //position sell
		           {
			         if(!ArrayPositionsSellProfitAndNewPositionsUpdate())
			         {
			         	PrintDebugErrorFunctionMessage(ReturnedFalseError("ArrayPositionsSellProfitAndNewPositionsUpdate"));
			         }
			      }
			      dloProfitPositions += PositionGetDouble(POSITION_PROFIT); //procurar valor do preço na moeda da conta SYMBOL_TRADE_TICK_VALUE SYMBOL_TRADE_TICK_VALUE_PROFIT SYMBOL_TRADE_FACE_VALUE SYMBOL_TRADE_CALC_MODE SYMBOL_PRICE_CHANGE SYMBOL_FORMULA SYMBOL_CURRENCY_PROFIT SYMBOL_CALC_MODE_FOREX;	transformar preço em valor da conta corrente
         }
      }
   }
   if(ArrayPositionsBuy.Total()>0 && ArrayPositionsSell.Total()>0)
   {
   	int i=0,j=0;
	   CPositionInfoMy *PositionInfoMy;
	   do
	     {
		   if(!ArrayPositionsBuy.IsSorted(SORT_BY_IS_PAIR))	ArrayPositionsBuy.Sort(SORT_BY_IS_PAIR);
		   IsFirstPassDeclaration1(lIsFirstPass5900);
		   while((PositionInfoMy = new CPositionInfoMy(0,0,false)) == NULL || CheckPointer(PositionInfoMy)==POINTER_INVALID)
		   {
		   	PrintDebugErrorIsFirstPass2FunctionMessage(lIsFirstPass5900, 
		   													"Falha ao criar o objeto/ponteiro PositionInfoMy = new CPositionInfoMy(0,0,false) == NULL.");
		   }
		   ElseIsFirstPass3(lIsFirstPass5900);
		   i = ArrayPositionsBuy.SearchLast(PositionInfoMy);
		   if(i!=-1)
		     {
			   if(!ArrayPositionsSell.IsSorted(SORT_BY_IS_PAIR))	ArrayPositionsSell.Sort(SORT_BY_IS_PAIR);
			   j = ArrayPositionsSell.SearchLast(PositionInfoMy);
			   if(j!=-1)
			     {
				   ArrayPositionsBuy.Sort(SORT_BY_IS_PAIR_AND_PROFIT);
				   ArrayPositionsSell.Sort(SORT_BY_IS_PAIR_AND_PROFIT);
		         int count5916=0;
		         bool bloUpdatedBuy=false, bloUpdatedSell=false;
		         do
		           {
					   PointerCreateWhileInvalidlCountPntrNameArryNamIndxCmmndsExtrs5P(count5960,PositionInfoMyBuy,ArrayPositionsBuy,i,);
					   PointerCreateWhileInvalidlCountPntrNameArryNamIndxCmmndsExtrs5P(count5961,PositionInfoMySell,ArrayPositionsSell,j,);
					   count5916++;
		            if(PositionInfoMyBuy!=NULL && PositionInfoMySell!=NULL)
		              {
		               //atualiza ambos os elementos dos vetores para é par
		               PositionInfoMyBuy.IsPair(true);
		               PositionInfoMySell.IsPair(true);
		              	bloUpdatedBuy=bloUpdatedSell=true;
		              }
		           }//se a atualizção de ambos ocorrerem com sucesso, então sai do do while e vai em busca dos próximos não par de cada vetor a 
		           //serem atualizados
		         while((PositionInfoMyBuy==NULL || PositionInfoMySell==NULL 
		         		|| CheckPointer(PositionInfoMyBuy)==POINTER_INVALID || CheckPointer(PositionInfoMySell)==POINTER_INVALID) 
		         		&& (!bloUpdatedBuy || !bloUpdatedSell) && count5916<TRIES_OPEN_CLOSE_MODIFY_DELETE);
		        }
		     }
		   else //não existe elemento no vetor que não seja par
		     {
		      break;
		     }
	     }
	   while(i!=-1 && j!=-1);

		delete PositionInfoMy;
   }
   return(dloProfitPositions);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool PositionCloseAndCheckAllPairByType(ENUM_POSITION_TYPE lType, string lSymbol, ulong lMagicNumber)
{
   bool res = true;
	if(lType==POSITION_TYPE_BUY)
	  {
	   for(int i = ArrayPositionsBuy.Total() - 1; i >= 0 ; i--)
	   {
	      PointerCreateWhileInvalidlCountPntrNameArryNamIndxCmmndsExtrs5P(count4040,PositionInfoMyBuy,ArrayPositionsBuy,i,continue);
	      LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass1, lCountTries1)
	      if(PositionInfoMyBuy.Ticket() == 0)  	//recomeçar contagem
	      {
	         LoopPrint2CountLooplCountTries(lCountTries1)
	         Print("Ticket==0" + FunctionLine);
	         LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass1)
	         res = false;
            if(!ArrayPositionsBuy.Delete(i))	//será que esse delete tbm deleta o ponteiro positionmybuy e todos os seus dados armazenados dentro do array? testar
            {
            	PrintDebugErrorFunctionMessage( ("ArrayPositionsBuy.Delete"));
               res = false;
               bglArrayPositionsBuyAndSellCheckToDeleteClosedPositionsElements=true;
            }
	         continue;
	      }
	      else
	      {
	         if(!PositionInfoMyBuy.IsPair())
	           {
	            continue;
	           }
	         LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass1, lCountTries1);
	         if(PositionProfitByTicketFull(PositionInfoMyBuy.Ticket())>0)
	         {
	            LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass2, lCountTries2)
	            if(!PositionCloseAndCheck(PositionInfoMyBuy.Ticket()))
	            {
	               LoopPrint2CountLooplCountTries(lCountTries2)	Print("PositionCloseAndCheck returned false." + FunctionLine);
	               LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass2)
	               res = false;
	            }
	            else
	            {
	               LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass2, lCountTries2);
	               //remover elemento do vetor
	               if(!ArrayPositionsBuy.Delete(i))
	               {
	               	PrintDebugErrorFunctionMessage( ("ArrayPositionsBuy.Delete"));
		               res = false;
		               //ativar uma posterior remoção do elemento em uma função específica para isso
		               bglArrayPositionsBuyAndSellCheckToDeleteClosedPositionsElements=true;
	               }
	            }
	         }
	      }
	   }
	  }
	else	//position sell
	  {
	   for(int i = ArrayPositionsSell.Total() - 1; i >= 0 ; i--)
	   {
	      PointerCreateWhileInvalidlCountPntrNameArryNamIndxCmmndsExtrs5P(count4115,PositionInfoMySell,ArrayPositionsSell,i,continue);
	      LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass1, lCountTries1)
	      if(PositionInfoMySell.Ticket() == 0)  	//recomeçar contagem
	      {
	         LoopPrint2CountLooplCountTries(lCountTries1)
	         Print("Ticket==0" + FunctionLine);
	         LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass1)
	         res = false;
	         //deletar elemento, já que não se sabe o ticket
            if(!ArrayPositionsSell.Delete(i))
            {
            	PrintDebugErrorFunctionMessage( ("ArrayPositionsSell.Delete"));
               res = false;
               //ativar uma posterior remoção do elemento em uma função específica para isso               	
               bglArrayPositionsBuyAndSellCheckToDeleteClosedPositionsElements=true;
            }
	         continue;
	      }
	      else
	      {
	         if(!PositionInfoMySell.IsPair())
	           {
	            continue;
	           }
	         LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass1, lCountTries1);
	         if(PositionProfitByTicketFull(PositionInfoMySell.Ticket())>0)
	         {
	            LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass2, lCountTries2)
	            if(!PositionCloseAndCheck(PositionInfoMySell.Ticket()))
	            {
	               LoopPrint2CountLooplCountTries(lCountTries2)	Print("PositionCloseAndCheck returned false." + FunctionLine);
	               LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass2)
	               res = false;
	            }
	            else
	            {
	               LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass2, lCountTries2);
	               //remover elemento do vetor
	               if(!ArrayPositionsSell.Delete(i))
	               {
	               	PrintDebugErrorFunctionMessage( ("ArrayPositionsSell.Delete"));
		               res = false;
		               //ativar uma posterior remoção do elemento em uma função específica para isso
		               bglArrayPositionsBuyAndSellCheckToDeleteClosedPositionsElements=true;
	               }
	            }
	         }
	      }
	   }
	  }
   return(res);
}

//+------------------------------------------------------------------+
//| Função que irá deletar as posições do array
//+------------------------------------------------------------------+
bool ArrayDeleteAllPositions(CArrayObj *lArray)
{
PrintDebugTempFunctionMessage("ArrayPositionsBuy.Total() "+ArrayPositionsBuy.Total()+" ArrayPositionsSell.Total() "+ArrayPositionsSell.Total());
PrintDebugTempFunctionMessage("RAM antes de deletar o vetor "+TerminalInfoInteger(TERMINAL_MEMORY_USED)+" MB.");
	if(!lArray.DeleteRange(0,lArray.Total()-1))
	{
		PrintDebugErrorFunctionMessage("Não conseguiu deletar o vetor de posições. "+ ("DeleteRange"));
		return false;
	}
	delete lArray;
PrintDebugTempFunctionMessage("RAM depois de deletar o vetor "+TerminalInfoInteger(TERMINAL_MEMORY_USED)+" MB.");
	return true;
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double PositionProfitByTicketFull(ulong lTicket)
{
	if(!PositionSelectByTicket(lTicket))
	  {
	   PrintDebugErrorFunctionMessage( ("PositionSelectByTicket Ticket:"+IntegerToString(lTicket)));
	   return 0;
	  }
	return(PositionGetDouble(POSITION_PROFIT)+PositionGetDouble(POSITION_SWAP)+PositionGetDouble(POSITION_COMMISSION));//position.Commission());//verificar se existem mais valores a acrescentar aqui como valores de comissão por lote (rebate)
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void PointerDeleteWhenArrayIsEmpty()
{
	static int iloTotalPreviousBuy=0,iloTotalPreviousSell=0;
	if(iloTotalPreviousBuy!=0 && ArrayPositionsBuy.Total()==0)
	  {
PrintDebugTempFunctionMessage("RAM antes de deletar o ponteiro buy "+TerminalInfoInteger(TERMINAL_MEMORY_USED)+" MB.");
	   delete PositionInfoMyBuy;
PrintDebugTempFunctionMessage("RAM depois de deletar o ponteiro buy "+TerminalInfoInteger(TERMINAL_MEMORY_USED)+" MB.");
	  }
	iloTotalPreviousBuy=ArrayPositionsBuy.Total();
	if(iloTotalPreviousSell!=0 && ArrayPositionsSell.Total()==0)
	  {
PrintDebugTempFunctionMessage("RAM antes de deletar o ponteiro sell "+TerminalInfoInteger(TERMINAL_MEMORY_USED)+" MB.");
	   delete PositionInfoMySell;
PrintDebugTempFunctionMessage("RAM depois de deletar o ponteiro sell "+TerminalInfoInteger(TERMINAL_MEMORY_USED)+" MB.");
	  }
	iloTotalPreviousSell=ArrayPositionsSell.Total();
}

//+------------------------------------------------------------------+
//▒▒▒▒▒▒▒▒▒▒     Verifica se é uma nova barra                         ▒▒▒▒▒▒▒▒▒▒
//+------------------------------------------------------------------+
bool IsNewBar(const string lSymbol, ENUM_TIMEFRAMES lTimeframe)
{
//--- memorize the time of opening of the last bar in the static variable
   static datetime last_time = 0;
//--- current time
   datetime lastbar_time = (datetime)SeriesInfoInteger(lSymbol, lTimeframe, SERIES_LASTBAR_DATE);
//--- if it is the first call of the function
   if(last_time == 0)
   {
      //--- set the time and exit
      last_time = lastbar_time;
      return(false);
   }
//--- if the time differs
   if(last_time != lastbar_time)
   {
      //--- memorize the time and return true
      last_time = lastbar_time;
      return(true);
   }
//--- if we passed to this line, then the bar is not new; return false
   return(false);
}

//+------------------------------------------------------------------+
//	Open Position Check and send order if all OK
//+------------------------------------------------------------------+
bool PositionOpenOrderCheckSend(ENUM_ORDER_TYPE lOrderType, string lSymbol, ulong lMagicNumber, double lVolume, double lSL_Price = 0, double lTP_Price = 0, int lDeviation = -1)
{
   LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass1, lCountTries1)
   if(lOrderType != ORDER_TYPE_BUY && lOrderType != ORDER_TYPE_SELL)
   {
      LoopPrint2CountLooplCountTries(lCountTries1)	Print("Order is not buy or sell error." + FunctionLine);
      LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass1)
      return(false);
   }
   else
      LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass1, lCountTries1);

   ZeroMemory(TrReq);
   LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass2, lCountTries2)
   if(!CheckVolumeValueAndCorrects(lVolume, lSymbol))
   {
      LoopPrint2CountLooplCountTries(lCountTries2)	Print("CheckVolumeValueAndCorrects returned false. " + FunctionLine);
      LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass2)
   }
   else
      LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass2, lCountTries2);

//	fazer as verificações do preço de abertura, do sl e tp em relação ao preço atual e corrigir se for o caso
   double lPrice;
   double pointInPrice = SymbolInfoDouble(lSymbol, SYMBOL_POINT);
   int stopLevelInPoints = int(SymbolInfoInteger(lSymbol, SYMBOL_TRADE_STOPS_LEVEL));
   double lTickSize = SymbolInfoDouble(lSymbol, SYMBOL_TRADE_TICK_SIZE);
   if(lOrderType == ORDER_TYPE_BUY)
   {
      lPrice = SymbolInfoDouble(lSymbol, SYMBOL_ASK);
      //if(lTP_Price > 0 && ((lTP_Price - lPrice) / pointInPrice) < stopLevelInPoints)
      //   lTP_Price = NormalizePriceSymbol(lSymbol, stopLevelInPoints * pointInPrice + lPrice + lTickSize); 	//não respeitou a distância mínima (stopLevel) em relação ao preço
      //if(((lPrice - lSL_Price) / pointInPrice) < stopLevelInPoints)
      //   lSL_Price = NormalizePriceSymbol(lSymbol, -stopLevelInPoints * pointInPrice + lPrice - lTickSize); 	//não respeitou a distância mínima (stopLevel) em relação ao preço
   }
   else  	//lOrderType == ORDER_TYPE_SELL
   {
      lPrice = SymbolInfoDouble(lSymbol, SYMBOL_BID);
      //if(((lPrice - lTP_Price) / pointInPrice) < stopLevelInPoints)
      //   lTP_Price = NormalizePriceSymbol(lSymbol, -stopLevelInPoints * pointInPrice + lPrice - lTickSize); 	//não respeitou a distância mínima (stopLevel) em relação ao preço
      //if(lSL_Price > 0 && ((lSL_Price - lPrice) / pointInPrice) < stopLevelInPoints)
      //   lSL_Price = NormalizePriceSymbol(lSymbol, stopLevelInPoints * pointInPrice + lPrice + lTickSize); 	//não respeitou a distância mínima (stopLevel) em relação ao preço
   }
   if(lDeviation < 0)	lDeviation = Slippage;

   TrReq.comment = " ";
   TrReq.deviation = lDeviation;                   // Maximal possible Slippage from the requested price
   TrReq.sl = NormalizePriceSymbol(lSymbol, lSL_Price);	   // Stop Loss level of the order
   TrReq.tp = NormalizePriceSymbol(lSymbol, lTP_Price);	   // Take Profit level of the order
   TrReq.price = NormalizePriceSymbol(lSymbol, lPrice);
   TrReq.magic = lMagicNumber;
   TrReq.symbol = lSymbol;               // Trade symbol
   TrReq.type_filling = OrderTypeFilling(lSymbol); // Order execution type
   TrReq.type = lOrderType;            // Order type
   TrReq.action = TRADE_ACTION_DEAL;
   TrReq.volume = NormalizeDouble(lVolume, 2);	   // Volume of the order

   if(!OrderCheckSend())
   {
      PrintDebugErrorFunctionMessage(ReturnedFalseError("OrderCheckSend"));
      return(false);
   }
   return(true);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string Error()
{
   if(Language == Portugues)
      return(" Retornou o erro: " + ErrorDescription(_LastError) + ", código: " + IntegerToString(_LastError));
   else//if (Language == English)
      return(" Returned the error: " + ErrorDescription(_LastError) + ", code: " + IntegerToString(_LastError));
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string OccurredError(string lFunctionName)
{
   if(Language == Portugues)
      return (OcorreuErro() + lFunctionName + ". " + Error());
   else//if (Language == English)
      return (OccurredError() + lFunctionName + ". " + Error());
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string OccurredError()
{
   return("An error occurred in ");
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string OcorreuErro()
{
   return("Ocorreu um erro no ");
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double NormalizePriceSymbol(string lSymbol, double lPrice)
{
   if(!SymbolInfo.Name(lSymbol))
   {
      if(DebugError)
         Print(OccurredError("SymbolInfo.Name(lSymbol) ") + FunctionLine);
   }
   else
   {
      if(!SymbolInfo.Refresh())
      {
         if(DebugError)
            Print(OccurredError("SymbolInfo.Refresh() ") + FunctionLine);
      }
      else
      {
         return(SymbolInfo.NormalizePrice(lPrice));
      }
   }
   return(NormalizeDouble(lPrice,(int)SymbolInfoInteger(lSymbol,SYMBOL_DIGITS)));	//falha na seleção ou no refresh
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool NormalizePriceSymbol(string lSymbol, double lPrice, double &lPriceReturned)
{
   if(!SymbolInfo.Name(lSymbol))
   {
      if(DebugError)
         Print(OccurredError("SymbolInfo.Name(lSymbol) ") + FunctionLine);
   }
   else
   {
      if(!SymbolInfo.Refresh())
      {
         if(DebugError)
            Print(OccurredError("SymbolInfo.Refresh() ") + FunctionLine);
      }
      else
      {
         lPriceReturned = SymbolInfo.NormalizePrice(lPrice);
         return(true);
      }
   }
   lPriceReturned = NormalizeDouble(lPrice,(int)SymbolInfoInteger(lSymbol,SYMBOL_DIGITS));
   return(false);	//falha na seleção ou no refresh
}

//+------------------------------------------------------------------+
//	Check and send order if all OK
//+------------------------------------------------------------------+
bool OrderCheckSend()
{
   string action, result;
   static bool lIsFirstPass = true;
//--- order check
   ZeroMemory(checkResult);
   LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass1, lCountTries1)
   if(!OrderCheck(TrReq, checkResult))
   {
      trRes.retcode = checkResult.retcode;
      if(DebugError && lIsFirstPass)
      {
         PrintDebugErrorFunctionMessage(ReturnedFalseError("OrderCheck"));
         printf(__FUNCTION__ + ": %s [%s]", trade.FormatRequest(action, TrReq), trade.FormatRequestResult(result, TrReq, trRes));
         lIsFirstPass = false;
      }
      LoopPrint2CountLooplCountTries(lCountTries1)	Print(TradeRetCodeError());
      LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass1)
      Sleep(SLEEP_AFTER_EXECUTION_FAIL);
      //--- copy return code
      return(false);
   }
   else
      LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass1, lCountTries1);

//--- order send
   ZeroMemory(trRes);
   LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass2, lCountTries2)
   if(!OrderSend(TrReq, trRes))
   {
      if(DebugError && lIsFirstPass)
      {
         PrintDebugErrorFunctionMessage(ReturnedFalseError("OrderSend"));
         printf(__FUNCTION__ + ": %s [%s]", trade.FormatRequest(action, TrReq), trade.FormatRequestResult(result, TrReq, trRes));
         lIsFirstPass = false;
      }
      LoopPrint2CountLooplCountTries(lCountTries2)	Print(TradeRetCodeError());
      LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass2)
      Sleep(SLEEP_AFTER_EXECUTION_FAIL);
      return(false);
   }
   else
      LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass2, lCountTries2);

   lIsFirstPass = true;
   return(true);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string TradeRetCodeError()
{
   if(Language == Portugues)
      return ("Código do erro: " + IntegerToString(trade.ResultRetcode()) + ". Descrição do código: " + trade.ResultRetcodeDescription());
   else//if (Language == English)
      return ("Error code: " + IntegerToString(trade.ResultRetcode()) + ". Description code: " + trade.ResultRetcodeDescription());
}

//+------------------------------------------------------------------+
//| Check the correctness of the order volume                        |
//+------------------------------------------------------------------+
bool CheckVolumeValueAndCorrects(double & volume, string lSymbol)
{
   volume = NormalizeDouble(volume, 2);	   // Volume of the order

   double min_volume = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_MIN);
   LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass1, lCountTries1)
   if(volume < min_volume)
   {
      LoopPrint2CountLooplCountTries(lCountTries1)	PrintFormat("Volume is Lower then minimal. ");
      LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass1)
      volume = min_volume;
      return(false);
   }
   else
      LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass1, lCountTries1);

//--- maximal allowed volume of trade operations
   double max_volume = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_MAX);
   LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass2, lCountTries2)
   if(volume > max_volume)
   {
      LoopPrint2CountLooplCountTries(lCountTries2)	Print("Volume is higher then maximal. ");
      LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass2)
      volume = max_volume;
      return(false);
   }
   else
      LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass2, lCountTries2);

//--- get minimal step of volume changing
   double volume_step = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_STEP);

   int ratio = (int)MathRound(volume / volume_step);
   LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass3, lCountTries3)
   if(MathAbs(ratio * volume_step - volume) > 0.0000001)
   {
      LoopPrint2CountLooplCountTries(lCountTries3)	PrintFormat("Volume is wrong with step volume. ");
      LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass3)
      volume = NormalizeDouble(ratio * volume_step, 2);
      return(false);
   }
   else
      LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass3, lCountTries3);

   return(true);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string ReturnedFalseError(string lFunctionName)
{
   if(Language == Portugues)
      return (lFunctionName + " retornou falso. ");
   else//if (Language == English)
      return (lFunctionName + " returned false. ");
}

//+------------------------------------------------------------------+
//| Inicializa o tipo de preenchimento de ordens conforme o tipo permitido pela corretora                                                                 |
//+------------------------------------------------------------------+
void TradingFunctionsManagement(string lSymbol)  		//::initTrade() {
{
   //trade.SetTypeFillingBySymbol(lSymbol);
   if(IsFillingTypeAllowed(lSymbol, SYMBOL_FILLING_FOK))
   {
      trade.SetTypeFilling(ORDER_FILLING_FOK);
   }
   else if(IsFillingTypeAllowed(lSymbol, SYMBOL_FILLING_IOC))
   {
      trade.SetTypeFilling(ORDER_FILLING_IOC);
   }
   else
   {
      trade.SetTypeFilling(ORDER_FILLING_RETURN);
   }
}

//+------------------------------------------------------------------+
//| Verifica se um modo de preenchimento específico é permitido      |
//+------------------------------------------------------------------+
bool IsFillingTypeAllowed(string lSymbol, int fill_type)
{
//--- Obtém o valor da propriedade que descreve os modos de preenchimento permitidos
   int filling = (int)SymbolInfoInteger(lSymbol, SYMBOL_FILLING_MODE);
//--- Retorna true, se o modo fill_type é permitido
   return((filling & fill_type) == fill_type);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
ENUM_ORDER_TYPE_FILLING OrderTypeFilling(string lSymbol)
{
   if(IsFillingTypeAllowed(lSymbol, SYMBOL_FILLING_FOK))
   {
      return(ORDER_FILLING_FOK);
   }
   else if(IsFillingTypeAllowed(lSymbol, SYMBOL_FILLING_IOC))
   {
      return(ORDER_FILLING_IOC);
   }
   else
   {
      return(ORDER_FILLING_RETURN);
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool ArrayPositionsBuyProfitAndNewPositionsUpdate()
{
   if(!ArrayPositionsBuy.IsSorted(SORT_BY_TICKET))
     {
      ArrayPositionsBuy.Sort(SORT_BY_TICKET);
     }
   PointerAtribWhileInvalidlIsFstPssPntrNameCnstrctrWthPrm(lIsFirstPass6955,PositionInfoMyBuy,
   					CPositionInfoMy(PositionGetInteger(POSITION_TICKET),PositionGetDouble(POSITION_PROFIT),false));
   
   int j = ArrayPositionsBuy.Search(PositionInfoMyBuy);
   if(j!=-1)
     {
      PointerCreateWhileInvalidlCountPntrNameArryNamIndxCmmndsExtrs5P(count6979,PositionInfoMyBuy,ArrayPositionsBuy,j,return false);//)==NULL || CheckPointer(PositionInfoMy)==POINTER_INVALID) && count5690<TRIES_OPEN_CLOSE_MODIFY_DELETE);
      PositionInfoMyBuy.Profit(PositionGetDouble(POSITION_PROFIT));
     }
   else //j==-1 ticket não está no array ainda
     {
      if(PositionGetDouble(POSITION_PROFIT) > 0)
      {
     	   if(!ArrayPositionsBuy.IsSorted(SORT_BY_IS_PAIR))	ArrayPositionsBuy.Sort(SORT_BY_IS_PAIR);
		   if(!ArrayPositionsBuy.InsertSort(PositionInfoMyBuy))
      	{
      		PrintDebugErrorFunctionMessage(OccurredError("ArrayPositionsBuy.InsertSort"));
	      	return false;
      	}
      }
     }
	return true;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool ArrayPositionsSellProfitAndNewPositionsUpdate()
{
   if(!ArrayPositionsSell.IsSorted(SORT_BY_TICKET))
     {
      ArrayPositionsSell.Sort(SORT_BY_TICKET);
     }
   PointerAtribWhileInvalidlIsFstPssPntrNameCnstrctrWthPrm(lIsFirstPass7055,PositionInfoMySell,
   					CPositionInfoMy(PositionGetInteger(POSITION_TICKET),PositionGetDouble(POSITION_PROFIT),false));
   int j = ArrayPositionsSell.Search(PositionInfoMySell);
   if(j!=-1)
     {
      PointerCreateWhileInvalidlCountPntrNameArryNamIndxCmmndsExtrs5P(count7067,PositionInfoMySell,ArrayPositionsSell,j,return false);
      PositionInfoMySell.Profit(PositionGetDouble(POSITION_PROFIT));
     }
   else //j==-1 ticket não está no array ainda
     {
      if(PositionGetDouble(POSITION_PROFIT)>0)
      {
     	   if(!ArrayPositionsSell.IsSorted(SORT_BY_IS_PAIR))	ArrayPositionsSell.Sort(SORT_BY_IS_PAIR);
		   if(!ArrayPositionsSell.InsertSort(PositionInfoMySell))
      	{
      		PrintDebugErrorFunctionMessage(OccurredError("ArrayPositionsSell.InsertSort"));
	      	return false;
      	}
      }
     }
	return true;
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string AtError(string lString)
{
   if(Language == Portugues)
      return ("Erro ao selecionar elemento em " + lString + Error());
   else//if (Language == English)
      return ("Element select error at " + lString + Error());
}

//+------------------------------------------------------------------+
//| remover as ordens pendentes caso esteja fora horário permitido de operações
//+------------------------------------------------------------------+
bool PositionCloseAndCheck(ulong lTicket)
{
   bool result = true;
   LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass1, lCountTries1)
   LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass2, lCountTries2)
   if(!trade.PositionClose(lTicket))
   {
      LoopPrint2CountLooplCountTries(lCountTries1)	Print(OccurredError("PositionClose") + FunctionLine);
      LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass1)
      Sleep(SLEEP_AFTER_EXECUTION_FAIL);
      result = PositionIsClosed(lTicket);
   }
   else
   {
      LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass1, lCountTries1);
      if(!TradeRetcodeIsDone())
      {
         LoopPrint2CountLooplCountTries(lCountTries2)	PrintDebugErrorFunctionMessage(ReturnedFalseError("TradeRetcodeIsDone"));
         LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass2)
         //se esta posição não foi fechada, então result = false
         Sleep(SLEEP_AFTER_EXECUTION_FAIL);
         result = PositionIsClosed(lTicket);
      }
      else
      {
         LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass2, lCountTries2);
      }
   }
   return(result);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool TradeRetcodeIsDone()
{
   LoopPrint1DeclarationVariableslIsFirstPasslCountTries(lIsFirstPass1, lCountTries1)
   if(TRADE_RETCODE_DONE == trade.ResultRetcode())
   {
      LoopPrint4PrintLoopConcludedlIsFirstPasslCountTries(lIsFirstPass1, lCountTries1);
      return(true);
   }

   LoopPrint2CountLooplCountTries(lCountTries1)	Print(TradeRetCodeError() + Error() + FunctionLine);
   LoopPrint3PrintLoopStartedlIsFirstPass(lIsFirstPass1)
   return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool PositionIsClosed(ulong lTicket)
{
   if(!PositionSelectByTicket(lTicket)) return(true);
   return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string PositionCloseAndCheckError()
{
   if(Language == Portugues)
      return ("Erro ao fechar a posição/operação. ");
   else//if (Language == English)
      return ("Error closing the position/operation. ");
}
